<script lang="ts" setup>
import { useproductStore } from '@/stores/Product'
import { usePromotionStore } from '@/stores/Promotion'
import { computed, onMounted, ref, watch } from 'vue'
import PromotionText from '@/components/PromotionComponent/PromotionText.vue'
import type { Promotion } from '@/types/Promotion'
import { useReceiptStore } from '@/stores/receipt'

const promotionStore = usePromotionStore()
const productStore = useproductStore()
const receiptStore = useReceiptStore()

const usingTime = ref(0)

const props = defineProps<{
  promotion: Promotion
}>()

const increase = () => {
  if (calculateLimitedUsingTime.value != null) {
    if (usingTime.value < calculateLimitedUsingTime.value) {
      promotionStore.usePromotion(props.promotion)
      usingTime.value += 1
    }
  }
}
const decrease = () => {
  if (usingTime.value > 0) {
    promotionStore.disUsePromotion(props.promotion)
    usingTime.value -= 1
  }
}

const calculateLimitedUsingTime = computed(() => {
  if (
    props.promotion.promotionItems![0].productId === null &&
    props.promotion.promotionItems![0].conditionQty !== null
  ) {
    return noProductIdConditionQty()
  } else if (
    props.promotion.promotionItems![0].productId === null &&
    props.promotion.promotionItems![0].conditionPrice !== null
  ) {
    return noProductIdConditionPrice()
  } else if (
    props.promotion.promotionItems![0].productId !== null &&
    props.promotion.promotionItems![0].conditionQty !== null
  ) {
    return haveProductIdConditionQty()
  } else if (
    props.promotion.promotionItems![0].productId !== null &&
    props.promotion.promotionItems![0].conditionPrice !== null
  ) {
    return haveProductIdConditionPrice()
  }
  return 0
})
const noProductIdConditionQty = () => {
  if (
    props.promotion.promotionItems![0].productId === null &&
    props.promotion.promotionItems![0].conditionQty !== null
  ) {
    let totalunit = 0
    for (const item of receiptStore.receiptItems) {
      totalunit = item.unit + totalunit
    }
    if (totalunit >= props.promotion.promotionItems![0].conditionQty) {
      return 1
    }
  }
  return 0
}
const noProductIdConditionPrice = () => {
  if (
    props.promotion.promotionItems![0].productId === null &&
    props.promotion.promotionItems![0].conditionPrice !== null
  ) {
    let totalprice = 0
    for (const item of receiptStore.receiptItems) {
      totalprice = totalprice + item.unit * item.price
    }
    if (totalprice >= props.promotion.promotionItems![0].conditionPrice) {
      console.log('totalprice =', totalprice)
      return 1
    }
  }
  return 0
}
const haveProductIdConditionQty = () => {
  if (
    props.promotion.promotionItems![0].productId !== null &&
    props.promotion.promotionItems![0].conditionQty !== null
  ) {
    const result = receiptStore.receiptItems.find(
      (receiptItem) => receiptItem.productId === props.promotion.promotionItems![0].productId
    )
    if (result !== null) {
      let totalunit = result?.unit

      if (totalunit! >= props.promotion.promotionItems![0].conditionQty) {
        const count = totalunit! / props.promotion.promotionItems![0].conditionQty
        console.log('count =', count)
        const flooredCount = Math.floor(count)
        return flooredCount
      }
    }
  }
  return 0
}
const haveProductIdConditionPrice = () => {
  if (
    props.promotion.promotionItems![0].productId !== null &&
    props.promotion.promotionItems![0].conditionPrice !== null
  ) {
    const result = receiptStore.receiptItems.find(
      (receiptItem) => receiptItem.productId === props.promotion.promotionItems![0].productId
    )
    if (result !== null) {
      let totalprice = 0
      totalprice = result?.price! * result?.unit!
      if (totalprice >= props.promotion.promotionItems![0].conditionPrice) {
        const count = totalprice / props.promotion.promotionItems![0].conditionPrice
        console.log('count =', count)
        const flooredCount = Math.floor(count)
        return flooredCount
      }
    }
  }
  return 0
}
</script>
<template>
  <!-- use button group to group it -->
  <!-- use v-model at v-radio group it won't work at the v-radio -->

  <div>
    <!-- mb = marginbelow -->
    <v-card
      class="mx-auto my-4"
      width="400"
      prepend-icon="mdi-ticket-percent-outline"
      :id="'card-' + promotion.id"
      :class="{
        cardcannotuse: promotion.status !== 'enable',
        cardcanuse: promotion.status === 'enable'
      }"
    >
      <template v-slot:title>
        <v-container>
          <v-row>
            {{ promotion.name }}
          </v-row>

          <v-row>
            <div>
              <v-btn
                :class="{
                  cardcannotuse: promotion.status !== 'enable',
                  radiocanuse: promotion.status === 'enable'
                }"
                class="ma-2"
                size="small"
                rounded
                @click="decrease()"
                :disabled="promotion.status === 'disable'"
                >-</v-btn
              >
              {{ usingTime }}
              <v-btn
                :class="{
                  cardcannotuse: promotion.status !== 'enable',
                  radiocanuse: promotion.status === 'enable'
                }"
                class="ma-2"
                size="small"
                rounded
                @click="increase()"
                :disabled="promotion.status === 'disable'"
                >+</v-btn
              >
              <p style="font-size: 15px">ใช้ได้ในตอนนี้ = {{ calculateLimitedUsingTime }}</p>
            </div>
          </v-row>
        </v-container>
      </template>

      <v-card-text class="text-body-1">
        <div class="ma-2">
          <PromotionText :promotionItems="promotion.promotionItems"></PromotionText>
        </div>

        <v-expansion-panels>
          <v-expansion-panel
            title="รายละเอียด"
            :class="{
              cardcannotuse: promotion.status !== 'enable',
              cardcanuse: promotion.status === 'enable'
            }"
          >
            <v-expansion-panel-text class="text-body-2">
              <p>วันเริ่มโปรโมชั่น: {{ promotion.startdate }}</p>
              <p>วันสิ้นสุดโปรโมชั่น: {{ promotion.enddate }}</p>
              <p>สถานะ: {{ promotion.status === 'enable' ? 'เปิดใช้งาน' : 'ปิดใช้งาน' }}</p>
            </v-expansion-panel-text>
          </v-expansion-panel>
        </v-expansion-panels>
      </v-card-text>
    </v-card>
  </div>
</template>
<style scoped>
/* this style for card that is not enable */
.cardcannotuse {
  background-color: #a2a2a2;
}

.cardcanuse {
  background-color: #ffffff;
}

.radiocanuse {
  background-color: #e5e4e2;
}
</style>
